/******************************************************************************

     ()
 .       v. 1.0

LinearSolve.cs                          

(c) 2002                 <xstazz@hotbox.ru>

               http://vt.spbgmtu.ru

******************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using GaussColLeadLib;


namespace LinearSolveApp
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.ComponentModel.Container components = null;

		private DataSet dataSet;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;				

		private bool isConstructed = false;

		public Form1()
		{
			InitializeComponent();
			CreateTable();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.dataGrid1.CaptionVisible = false;
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 36);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(596, 380);
			this.dataGrid1.TabIndex = 0;
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(112, 8);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   500,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   2,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(48, 20);
			this.numericUpDown1.TabIndex = 1;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 4,
																		 0,
																		 0,
																		 0});
			this.numericUpDown1.TextChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = " ";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(176, 4);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 3;
			this.button1.Text = "";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4,
																					  this.menuItem5});
			this.menuItem1.Text = "";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = " ...";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = " ...";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.* ";
			this.openFileDialog1.RestoreDirectory = true;
			this.openFileDialog1.Title = " ";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "xml";
			this.saveFileDialog1.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*";
			this.saveFileDialog1.RestoreDirectory = true;
			this.saveFileDialog1.Title = " ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(594, 415);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.label1,
																		  this.numericUpDown1,
																		  this.dataGrid1});
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(320, 240);
			this.Name = "Form1";
			this.Text = "     -     " +
				"   ";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// 
		private void CreateTable()
		{
			dataSet = new DataSet("LinearSolve");

			DataTable dataTable = new DataTable("A");
			dataSet.Tables.Add(dataTable);

			this.dataGrid1.SetDataBinding(dataSet,"A");
		
			isConstructed = true;

			// 
			this.numericUpDown1.Value = 3;
		}

		//  
		private void ResizeGrid()
		{
			if(!isConstructed) return;
			
			DataTable dt = this.dataSet.Tables["A"];

			int newRowCount = Convert.ToInt32(this.numericUpDown1.Value);
			int newColCount = newRowCount+2;
			int colCount = dt.Columns.Count;

			//   
			if(newColCount > colCount || newColCount < colCount)
			{
				//   
				DataTable newDt = new DataTable("A");

				DataColumn [] cols = new DataColumn[newColCount];

				// 
				for(int i=0; i<newColCount; i++)
				{
					DataColumn dataCol1 = new DataColumn("a"+(i+1),typeof(double));				
					dataCol1.DefaultValue = 0;
					cols[i] = dataCol1;
				}
				
				cols[newColCount-2].ColumnName = "b";
				cols[newColCount-1].ColumnName = "x";
				
				newDt.Columns.AddRange(cols);

				// 
				for(int i=0; i<newRowCount; i++)
				{
					DataRow dataRow1 = newDt.NewRow();				
					newDt.Rows.Add(dataRow1);
				}

				int colsToCopy = (newColCount < colCount) ? newColCount : colCount;
				int rowsToCopy = colsToCopy-2;

				//    
				for(int i=0; i<rowsToCopy; i++)
				{
					for(int j=0; j<colsToCopy; j++)
					{
						newDt.Rows[i][j] = dt.Rows[i][j];
					}
				}

				dataSet = new DataSet("LinearSolve");
				dataSet.Tables.Add(newDt);
				this.dataGrid1.SetDataBinding(dataSet,"A");
			}
			else
			{
				int rowCount = dt.Rows.Count;

				if(newRowCount > rowCount)
				{
					// 
					for(int i=0; i<newRowCount-rowCount; i++)
					{
						DataRow dataRow1 = dt.NewRow();				
						dt.Rows.Add(dataRow1);
					}
				}

				if(newRowCount < rowCount)
				{
					// 
					for(int i=0; i<rowCount-newRowCount; i++)
					{
						dt.Rows.RemoveAt(dt.Rows.Count-1);
					}
				}
			}
		}

		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			ResizeGrid();
		}

		private void Solve()
		{
			ResizeGrid();
			
			DataTable dt = this.dataSet.Tables["A"];
			int size = dt.Rows.Count;
			
			//  
			double [,] a = new double[size, size+1];

			// 
			double [] x;

			//  
			for(int i=0; i<size; i++)
			{
				for(int j=0; j<size+1; j++)
				{
					a[i,j] = Convert.ToDouble(dt.Rows[i][j]);
				}
			}
		
			//  
			GaussColLead gcl = new GaussColLead();

			x = gcl.Solve(a);

			// 
			for(int i=0; i<size; i++)
			{
				dt.Rows[i][size+1] = x[i];
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Solve();
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		//      
		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				dataSet = new DataSet("LinearSolve");
				dataSet.ReadXml(openFileDialog1.FileName, XmlReadMode.ReadSchema);
				this.numericUpDown1.Value = dataSet.Tables["A"].Rows.Count;
				this.dataGrid1.SetDataBinding(dataSet,"A");
			}
		}

		//      
		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				dataSet.WriteXml(saveFileDialog1.FileName, XmlWriteMode.WriteSchema);
			}
		}
	}
}
	